# [![Voila](https://i.ibb.co/R2T5Tvb/voila.png)](https://shields.io/)   [![forthebadge](https://forthebadge.com/images/badges/made-with-rust.svg)](https://forthebadge.com)   [![forthebadge](https://forthebadge.com/images/badges/built-with-love.svg)](https://forthebadge.com)

![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-2.1-4baaaa.svg)
[![GitHub license](https://img.shields.io/github/license/Alonely0/voila.svg)](https://github.com/Alonely0/voila/blob/master/LICENSE)
![Lines of code](https://img.shields.io/tokei/lines/github/Alonely0/Voila)
![GitHub release (latest SemVer)](https://img.shields.io/github/v/release/Alonely0/Voila?label=latest%20release)
![GitHub commits since latest release (by date)](https://img.shields.io/github/commits-since/Alonely0/Voila/latest/main)
![GitHub Release Date](https://img.shields.io/github/release-date/Alonely0/Voila?label=last%20release%20date)
![GitHub last commit](https://img.shields.io/github/last-commit/Alonely0/Voila)
![GitHub contributors](https://img.shields.io/github/contributors/Alonely0/Voila)
![OSS Lifecycle](https://img.shields.io/osslifecycle/Alonely0/Voila)
![Crates.io](https://img.shields.io/crates/d/voila?label=downloads%40%2A)
![Crates.io (latest)](https://img.shields.io/crates/dv/voila)
[![Linux build](https://github.com/Alonely0/Voila/actions/workflows/linux-ci.yml/badge.svg)](https://github.com/Alonely0/Voila/actions/workflows/linux-ci.yml)
[![macOS build](https://github.com/Alonely0/Voila/actions/workflows/mac-ci.yml/badge.svg)](https://github.com/Alonely0/Voila/actions/workflows/mac-ci.yml)
[![Windows build](https://github.com/Alonely0/Voila/actions/workflows/windows-ci.yml/badge.svg)](https://github.com/Alonely0/Voila/actions/workflows/windows-ci.yml)

Voila is a DSL (domain-specific language) for interacting in a fast, reliable, versatile, safe & multithreaded way with files & directories. It is based on a CLI tool, although you can write your Voila code and do something like this `voila DIRECTORY "$(cat operations.vla)"`. Voila is mainly tested in Linux, so should work better in \*nix (Linux, \*BSD, macOS, etc) than in Windows-based operating systems, but shouldn't be any problems on them. Voila is completely cross-platform.

Voila scripts are interpreted, but optionally you can [compile it](https://github.com/Alonely0/Voila/wiki/Compiling-a-Voila-script) like you'd do with other programming languages.

# Documentation
You can find the docs in the [wiki](https://github.com/Alonely0/Voila/wiki/Documentation).

# Installation

See [#Installation](https://github.com/Alonely0/Voila/wiki/Installation) in the docs.

# Submitting

* Errors: file an error issue using [this link](https://github.com/Alonely0/voila/issues/new?assignees=Alonely0&labels=bug&template=bug_report.md&title=). Remember to check if that issue is [already registered](https://github.com/Alonely0/voila/labels/bug)!
* Feature requests: file a f-request issue using [this link](https://github.com/Alonely0/voila/issues/new?assignees=Alonely0&labels=enhancement&template=feature_request.md&title=). Remember to check if that f-request was [already submitted](https://github.com/Alonely0/voila/labels/enhancement)!
* Doubt: file a doubt issue using [this link](https://github.com/Alonely0/voila/issues/new?assignees=Alonely0&labels=question&template=doubt.md&title=). Remember to check if that doubt [was already resolved](https://github.com/Alonely0/voila/labels/question)!
* Wanna chat with me? You can talk with me on [Discord](https://discord.com), add me as friend (`NOT-Guillem#8042`) and we'll be able to start chatting!
